/*
	File:		DLPIHWSpecific.c

	Contains:	This file contains the DriverDescription record necessary for the DLPI 
				environment that is hardware dependent.
				This file is a demonstration of a sample TheDriverDescription which is
				a required export for PCI Card DLPI drivers.
				For PC Card 3.0, this export symbol is currently not used.  A later release of PC Cards
				for PowerBooks may use this symbol in a manner similar to that by the PCI card
				loader

	Written by:	Rich Kubota

	Copyright:	 1994 by Apple Computer, Inc., all rights reserved.

	Change History (most recent first):


	To Do:
*/

#include <Devices.h>
#include <OpenTptLinks.h>
#include <OpenTptPCISupport.h>

// The following information is card specific and must be changed so that your card
// can be matched to your hardware
#define kPCIDeviceInfoName		"\ppcivendorID,deviceID"	// pascal string,vendor ID & device id
#define kModuleDeviceInfoName	"vendorID,deviceID"		// c string, vendor ID & device id

//-----------------------------------------------------------------------------------------
//	Description:
//		This data stucture entry point is exported through the cfm mechanism.  Information
//		about the hardware that this driver works with is located in this structure.
//		The following is specific for an Ethernet software driver.
//-----------------------------------------------------------------------------------------

enum
{
	kFrameFlags = kOTFramingEthernet | kOTFramingEthernetIPX | kOTFraming8022
};

DriverDescription TheDriverDescription =
{
// Signature Info
	kTheDescriptionSignature,					// signature always first
	kInitialDriverDescriptor,					// version second

// Type Info
	kPCIDeviceInfoName,							// Our name, module info name must match
	1,0,0,0,									// Major, Minor, Stage, Rev

// OS Runtime Info
	kDriverIsUnderExpertControl,				// Runtime Options
	"\penet",									// should be kEnetName
	0,0,0,0,0,0,0,0,							// reserve 8 longs

// OS Service Info
	1,											// Number of Service Categories							
	kServiceCategoryOpenTransport,				// We support the 'otan' category
	OTPCIServiceType(kOTEthernetDevice,kFrameFlags,0,1),
	1,0,0,0										// Major, Minor, Stage, Rev
};
