//	APane.cpp


#include <Timer.h>

#include "APane.h"
#include "ScreenTarget.h"

APane *
APane::CreateAPaneStream(
	LStream *stream)
{
	return new APane(stream);
}


void
APane::FinishCreate()
{
	theTarget = new ScreenTarget(GetMacPort());
}


void
APane::SetData(
	void *data,
	long rowBytes,
	long width,
	long height,
	long hPos,
	long vPos)
{
	theData = data;
	tWidth = width;
	tRowBytes = rowBytes;
	tHeight = height;
	tHPos = hPos;
	tVPos = vPos;
	theTarget->PutData(theData, tRowBytes, tWidth, tHeight, tVPos, tHPos);
}


void
APane::DrawSelf()
{
	if (theTarget && theData) {
		theTarget->PutData(theData, tRowBytes, tWidth, tHeight, tVPos, tHPos);
	}
}

